/**************************************************************************/
/*          InDesignで表計算（CS2 以降）［計算式実行プログラム］          */
/*                                                            by お～まち */
/*                                               2006.07.03  Version 1.20 */
/**************************************************************************/
if (app.selection.length == 1){
	if(app.selection[0].constructor.name == "Table"){
		tbl = app.selection[0];
		do_script(tbl);
	} else {
		alert("表を1つ選択してください");
	}
} else {
	alert("表を1つ選択してください")
}
function do_script(tbl){
	const addchr = ["\xa5","\$","%","@","円","￥","＄","％","＠","\xa2","\xa3"];
	const minuschr = ["\uff0d","△","▲"];
	var temparray = new Array();
	var cell_cell = new Array();
	var cell_adrs = new Array();
	var cell_type = new Array();
	var cell_fomt = new Array();
	var cell_calc = new Array();
	var cell_valu = new Array();
	//前準備
	var i = 0;
	for (c=0 ; c<tbl.cells.length ; c++){
		temparray = tbl.cells[c].label.split("#");
		if (temparray[1] == "数値" || temparray[1] == "計算式"){
			cell_cell[i] = c;
			cell_adrs[i] = temparray[0];
			cell_type[i] = temparray[1];
			cell_fomt[i] = temparray[2];
			cell_calc[i] = temparray[3];
			if (cell_type[i] == "数値"){
				var tempstr = tbl.cells[c].contents;
				tempstr = tempstr.replace(/,/,"").replace(/\s/,"");
				for (var j=0 ; j<minuschr.length ; j++){tempstr = tempstr.replace(minuschr[j],"-")}
				tempstr = tempstr.replace(/[－―‐\u2012]/,"-");
				for (j=0 ; j<addchr.length ; j++){tempstr = tempstr.replace(addchr[j],"")}
				if (tempstr == "-" || tempstr == ""){tempstr = "0"}
				if (isNaN(tempstr)){
					alert("数値に指定されたセルに、数字以外の文字があります。\n処理を中止します。");
					return;
				}
				cell_valu[i] = parseFloat(tempstr);
			}
			i = i+1;
		}
	}
	//ここから計算
	var loop_count = 0;
	var loopflag = true;
	while (loopflag){
		for (i=0 ; i<cell_cell.length ; i++){
			if (cell_type[i] == "計算式" && isNaN(cell_valu[i]) ){
				//temparray.length = 1;
				temparray = cell_calc[i].split(" ");
				for (j=0 ; j<temparray.length ; j++){
					tempchr1 = temparray[j].toUpperCase().charCodeAt(0);
					tempchr2 = temparray[j].charCodeAt(1);
					if (tempchr1 > 64 && tempchr1 < 91 && tempchr2 > 47 && tempchr2 < 58){
						for (var k=0 ; k<cell_cell.length ; k++){
							if (cell_adrs[k] == temparray[j].toUpperCase()){
								if (!isNaN(cell_valu[k])){
									temparray[j] = cell_valu[k];
								}
								break;
							}
						}
					}
				}
				cell_calc[i] = temparray.join(" ");
				//if (isFinite(cell_calc[i])){
				try { cell_valu[i] = eval(cell_calc[i]); }
				catch(e) { }
				//}
			}
		}
		//計算が完了しているか確認
		loopflag = false;
		for (i=0 ; i<cell_cell.length ; i++){
			if (cell_type[i] == "計算式" && isNaN(cell_valu[i]) ){
				loopflag = true;
				break;
			}
		}
		//繰り返し回数の制限
		loop_count = loop_count + 1;
		if (loop_count == 10){
			alert("セルの循環参照、０での除算など、計算式に誤りがある可能性があります。\n処理を打ち切りました");
			return;
		}
	}
	//値の整形
	for (i=0 ; i<cell_cell.length ; i++){
		if (cell_fomt[i] != "------"){
			cell_calc[i] = format_val(cell_fomt[i], cell_valu[i], minuschr);
		}
	}
	//書き込み
	for (i=0 ; i<cell_cell.length ; i++){
		if (cell_fomt[i] != "------"){
			tbl.cells[cell_cell[i]].contents = cell_calc[i];
		}
	}
	alert("計算が完了しました");
}
//整形サブルーチン
function format_val(fomt, valu, minuschr){
	var prestr = "";
	var poststr = "";
	var minusstr = "";
	var comstr = "";
	var valstr = "";
	var intstr = "";
	//前後の文字、負記号
	for (var j=0 ; j<minuschr.length ; j++){
		if (fomt.charAt(0) == minuschr[j]){break;}
	}
	if (j < minuschr.length){
		minusstr = fomt.charAt(0);
		fomt = fomt.substr(1);
	} else {
			prestr = fomt.charAt(0);
			minusstr = fomt.charAt(1);
			fomt = fomt.substr(2);
	}
	if (valu < 0){
		valu = -1 * valu;
	} else {
		minusstr = "";
	}
	if (fomt.charAt(fomt.length-1) != "0"){
		poststr = fomt.charAt(fomt.length - 1);
		fomt = fomt.substr(0, fomt.length - 1);
	}
	//小数点以下の桁数
	if (fomt.indexOf(".", 0) != -1){
		tempnum = fomt.length - fomt.indexOf(".", 0) - 1;
		valstr = "" + Math.round(valu * Math.pow(10, tempnum))/Math.pow(10, tempnum);
		if (valstr.indexOf(".", 0) == -1){valstr = valstr + "."}
		while (valstr.length < valstr.indexOf(".", 0) + tempnum + 1){
			valstr = valstr + "0";
		}
	} else {
		valstr = "" + Math.round(valu);
	}
	//カンマ区切り
	if (valstr.indexOf(".", 0) == -1){
		intstr = valstr;
		valstr = "";
	} else {
		intstr = valstr.substr(0, valstr.indexOf(".", 0));
		valstr = valstr.substr(valstr.indexOf(".", 0));
	}
	if (fomt.indexOf(",", 0) != -1){
		j= 1;
		while (intstr != ""){
			comstr = intstr.charAt(intstr.length - 1) + comstr;
			intstr = intstr.substr(0, intstr.length - 1);
			if (j % 3 == 0){comstr = "," + comstr}
			j = j + 1;
		}
		if (comstr.charAt(0) == ","){comstr = comstr.substr(1)}
	} else {
		comstr = intstr;
	}
	return prestr + minusstr + comstr + valstr + poststr;
}
